<?php

include "./sign-valid.php";

$mode = abs(intval($_GET["mode"]));
$act  = abs(intval($_GET["action"]));
$uid  = abs(intval($_GET["uid"]));

switch ($mode) {
    case '0':
	    $display = "<ul><li><a href='./admin.php?mode=1'>Управление дистрибутивами</a></li><li><a href='./admin.php?mode=2'>Управление версиями дистрибутивов</a></li><li><a href='./admin.php?mode=3'>Управление репозиториями</a></li><li><a href='./admin.php?mode=4'>Управление секциями репозиториев</a></li></ul>";
	    break;
    case '1':
	    // Работа с дистрибутивами
	    switch ($act) {
		case '0':
			// Список дистрибутивов
			$dist =& $db->query("SELECT * FROM distribution");
			if ($dist->numRows()>0) {
				$display = "В наличии есть:<ul id='distlist'>";
				while ($dist->fetchInto($info, DB_FETCHMODE_ASSOC)) {
				    $display .= "<li>".stripslashes($info["distname"])." &mdash; [<a href='./admin.php?mode=1&action=2&uid=".$info["dist_id"]."' class='edit'>править</a>][<a href='./admin.php?mode=1&action=3&uid=".$info["dist_id"]."' class='delete'>удалить</a>]</li>";
				}
				$display .= "</ul><p><a href='./admin.php?mode=1&action=1'>Добавить новый apt-дистрибутив</a></p>";
			}
			break;
		case '1':
			// Добавление нового дистрибутива
			$dtype =& $db->query("SELECT * FROM dtype");
			$type = "<select name='distType'>";
			while ($dtype->fetchInto($dtinfo, DB_FETCHMODE_ASSOC)) {
			    $type .= "<option value='".$dtinfo["type_id"]."'>".stripslashes($dtinfo["type"])."</option>";
			}
			$type .= "</select>\n";
			$display  = "<h3>Добавление нового apt-дистрибутива</h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='1'>\n";
			$display .= "Название дистрибутива: <input type='text' name='distName'><br>\n";
			$display .= "Тип дистрибутива: ".$type."<br>";
			$display .= "<input type='submit' value='Создать'></form>\n";
			break;
		case '2':
			// Правка существующего дистрибутива
			$dist =& $db->query("SELECT * FROM distribution WHERE dist_id='$uid'");
			$dist->fetchInto($info, DB_FETCHMODE_ASSOC);
			$dtype =& $db->query("SELECT * FROM dtype");
			$type = "<select name='distType'>";
			while ($dtype->fetchInto($dtinfo, DB_FETCHMODE_ASSOC)) {
			    if ($info["disttype"]==$dtinfo["type_id"]) {
				$type .= "<option value='".$dtinfo["type_id"]."' selected>".stripslashes($dtinfo["type"])."</option>";
			    } else {
				$type .= "<option value='".$dtinfo["type_id"]."'>".stripslashes($dtinfo["type"])."</option>";			    
			    }
			}
			$type .= "</select>\n";
			$display  = "<h3>Правка apt-дистрибутива <em>".stripslashes($info["distname"])."</em></h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='2'>\n";
			$display .= "<input type='hidden' name='distID' value='$uid'>\n";			
			$display .= "Название дистрибутива: <input type='text' name='distName' value='".stripslashes($info["distname"])."'><br>\n";
			$display .= "Тип дистрибутива: ".$type."<br>";
			$display .= "<input type='submit' value='Править'></form>\n";
			break;
		case '3':
			// Удаление существующего дистрибутива
			$dist =& $db->query("SELECT * FROM distribution WHERE dist_id='$uid'");
			$dist->fetchInto($info, DB_FETCHMODE_ASSOC);
			$display  = "<h3>Удаление apt-дистрибутива <em>".stripslashes($info["distname"])."</em></h3>";			
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='3'>\n";
			$display .= "<input type='hidden' name='distID' value='$uid'>\n";			
			$display .= "<input type='submit' value='Удалить'></form>\n";
			break;
	    }
	    break;
	case '2':
	    // Работа с версиями дистрибутивов
	    switch ($act) {
		case '0':
			// Все версии имеющихся дистрибутивов
			$dist =& $db->query("SELECT * FROM distribution d JOIN version v ON d.dist_id=v.dist_id ORDER BY d.dist_id,v.version ASC");
			$display  = "В наличии есть следующие версии apt-дистрибутивов:<ul id='distlist'>";
			while ($dist->fetchInto($info, DB_FETCHMODE_ASSOC)) {
			    $display .= "<li>".stripslashes($info["distname"])." ".stripslashes($info["version"])." &#8220;".stripslashes($info["vname"])."&#8221; &mdash; [<a href='./admin.php?mode=2&action=2&uid=".$info["version_id"]."' class='edit'>править</a>][<a href='./admin.php?mode=2&action=3&uid=".$info["version_id"]."' class='delete'>удалить</a>]</li>";
			}
			$display .= "</ul><p><a href='./admin.php?mode=2&action=1'>Добавить новую версию дистрибутива</a></p>";
			break;
		case '1':
			// Добавление новой версии дистрибутива
			$dtype =& $db->query("SELECT * FROM distribution");
			$type = "<select name='distName'>";
			while ($dtype->fetchInto($dtinfo, DB_FETCHMODE_ASSOC)) {
			    $type .= "<option value='".$dtinfo["dist_id"]."'>".stripslashes($dtinfo["distname"])."</option>";
			}
			$type .= "</select>\n";
			$display  = "<h3>Добавление новой версии apt-дистрибутива</h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='4'>\n";
			$display .= "Номер версии: <input type='text' name='versNum'><br>\n";
			$display .= "Название версии: <input type='text' name='versNam'><br>\n";			
			$display .= "Кодовое имя версии: <input type='text' name='versCN'><br>\n";
			$display .= "Дистрибутив: ".$type."<br>";
			$display .= "<input type='submit' value='Создать'></form>\n";
			break;
		case '2':
			// Правка имеющейся версии дистрибутива
			$vers =& $db->query("SELECT * FROM version v JOIN distribution d ON d.dist_id=v.dist_id WHERE version_id='$uid'");
			$vers->fetchInto($info, DB_FETCHMODE_ASSOC); 
			$display  = "<h3>Правка имеющейся версии <em>".stripslashes($info["distname"])."</em></h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='5'>\n";
			$display .= "<input type='hidden' name='versID' value='$uid'>\n";			
			$display .= "Номер версии: <input type='text' name='versNum' value='".stripslashes($info["version"])."'><br>\n";
			$display .= "Название версии: <input type='text' name='versNam' value='".stripslashes($info["vname"])."'><br>\n";			
			$display .= "Кодовое имя версии: <input type='text' name='versCN' value='".stripslashes($info["vcodename"])."'><br>\n";
			$display .= "<input type='submit' value='Править'></form>\n";
			break;
		case '3':
			// Удаление существующей версии дистрибутива
			$dist =& $db->query("SELECT * FROM version v JOIN distribution d ON v.dist_id=d.dist_id WHERE v.version_id='$uid'");
			$dist->fetchInto($info, DB_FETCHMODE_ASSOC);
			$display  = "<h3>Удаление версии ".stripslashes($info["version"])." (&#8220;".stripslashes($info["vname"])."&#8221;) <em>".stripslashes($info["distname"])."</em></h3>";			
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='6'>\n";
			$display .= "<input type='hidden' name='versID' value='$uid'>\n";			
			$display .= "<input type='submit' value='Удалить'></form>\n";
			break;
	    }
	    break;
        case '3':
            // Работа с репозиториями
            switch ($act) {
                case '0':
                        // Выбор дистрибутива
                        $dist =& $db->query("SELECT * FROM distribution d JOIN version v ON v.dist_id=d.dist_id");
			$display  = "В наличии есть следующие версии apt-дистрибутивов:<ul id='distlist'>";
			while ($dist->fetchInto($info, DB_FETCHMODE_ASSOC)) {
			    $display .= "<li><a href='./admin.php?mode=3&action=1&uid=".$info["version_id"]."'>".stripslashes($info["distname"])." ".stripslashes($info["version"])." &#8220;".stripslashes($info["vname"])."&#8221;</a></li>";
			}
			$display .= "</ul>";
                        break;
                case '1':
                        // Список доступных репозиториев для конкретной версии дистрибутива
                        $reps =& $db->query("SELECT * FROM repository r JOIN ver2rep a ON a.rep_id=r.rep_id JOIN rtype t ON r.reptype=t.rtype_id WHERE a.ver_id='$uid'");
                        $display = "Доступные репозитории для выбранного дистрибутива: <ul id='replist'>";
                        if ($reps->numRows()>0) {
                            while ($reps->fetchInto($info, DB_FETCHMODE_ASSOC)) {
                                $display .= "<li>[<a href='./admin.php?mode=3&action=3&uid=".$info["rep_id"]."' class='edit'>править</a>][<a href='./admin.php?mode=3&action=4&uid=".$info["rep_id"]."' class='delete'>удалить</a>] ".stripslashes($info["repname"])." (".stripslashes($info["rtype"]).") &mdash; ".stripslashes($info["repdescribe"])."</li>";
                            }
                        }
                        $display .= "</ul><p><a href='./admin.php?mode=3&action=2&uid=".$uid."'>Добавить новый репозиторий</a></p>";
                        break;
                case '2':
                        // Новый репозиторий
                        $rep =& $db->query("SELECT * FROM distribution d JOIN version v ON v.dist_id=d.dist_id WHERE v.version_id='$uid'");
                        $rep->fetchInto($dist, DB_FETCHMODE_ASSOC);
                        $dist_id = $dist["dist_id"];
                        $dist_vname = stripslashes($dist["distname"])." ".stripslashes($dist["version"])." &#8220;".stripslashes($dist["vname"])."&#8221;";
			$dtype =& $db->query("SELECT * FROM rtype");
			$type = "<select name='repType'>";
			while ($dtype->fetchInto($dtinfo, DB_FETCHMODE_ASSOC)) {
			    $type .= "<option value='".$dtinfo["rtype_id"]."'>".stripslashes($dtinfo["rtype"])."</option>";
			}
                        $sect =& $db->query("SELECT * FROM section s JOIN sect2dist d ON d.sect_id=s.sect_id WHERE d.dist_id='$dist_id'");
                        $list = "";
                        while ($sect->fetchInto($slist, DB_FETCHMODE_ASSOC)) {
                            $list .= "<input type='checkbox' name='sect[]' value='".$slist["sect_id"]."'> <span title='".stripslashes($slist["sectinfo"])."'>".stripslashes($slist["sectname"])."</span> ";
                        }
			$type .= "</select>\n";
			$display  = "<h3>Добавление нового репозитория для ".$dist_vname."</h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='7'>\n";
			$display .= "<input type='hidden' name='vers' value='$uid'>\n";
			$display .= "Название репозитория (codename): <input type='text' name='repName'><br>\n";
			$display .= "Описание репозитория:<br> <textarea name='repInfo'></textarea><br>\n";
                        $display .= "Тип репозитория: ".$type."<br>";
                        $display .= "Секции: ".$list;
			$display .= "<br><input type='submit' value='Создать'></form>\n";			
                        break;
                case '3':
            		// Редактирование репозитория
            		$rep =& $db->query("SELECT * FROM repository WHERE rep_id='$uid'");
            		$rep->fetchInto($info, DB_FETCHMODE_ASSOC);
            		$tlist = "<select name='repType'>";
            		$sq =& $db->query("SELECT * FROM rtype");
            		while ($sq->fetchInto($type, DB_FETCHMODE_ASSOC)) {
            		    if ($type["rtype_id"]==$info["reptype"]) {
            			$tlist .= "<option value='".$type["rtype_id"]."' selected>".stripslashes($type["rtype"])."</option>";
            		    } else {
            			$tlist .= "<option value='".$type["rtype_id"]."'>".stripslashes($type["rtype"])."</option>";
            		    }
            		}
            		$tlist .= "</select>";
            		$list = "";
            		$req =& $db->query("SELECT * FROM section s JOIN sect2rep r ON s.sect_id=r.sect_id WHERE r.rep_id='$uid'");
            		if ($req->numRows()>0) {
            		    while ($req->fetchInto($sect, DB_FETCHMODE_ASSOC)) {
            			$list .= "<input type='checkbox' name='sect[]' value='".$sect["sect_id"]."' checked><span title='".stripslashes($sect["sectinfo"])."'>".stripslashes($sect["sectname"])."</span> ";
            		    }
            		}
            		$req =& $db->query("SELECT s.* FROM section s WHERE s.sect_id NOT IN (SELECT sect_id FROM sect2rep WHERE rep_id='$uid')");
            		if ($req->numRows()>0) {
            		    while ($req->fetchInto($sect, DB_FETCHMODE_ASSOC)) {
            			$list .= "<input type='checkbox' name='sect[]' value='".$sect["sect_id"]."'><span title='".stripslashes($sect["sectinfo"])."'>".stripslashes($sect["sectname"])."</span> ";
            		    }
            		}
			$display  = "<h3>Правка репозитория ".$info["repname"]." для <em>".$dist_name."</em></h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='8'>\n";
			$display .= "<input type='hidden' name='rep' value='$uid'>\n";
			$display .= "Название репозитория (codename): <input type='text' name='repName' value='".stripslashes($info["repname"])."'><br>\n";
			$display .= "Описание репозитория:<br> <textarea name='repInfo'>".stripslashes($info["repdescribe"])."</textarea><br>\n";
                        $display .= "Тип репозитория: ".$tlist."<br>";
                        $display .= "Секции: ".$list;
			$display .= "<br><input type='submit' value='Править'></form>\n";			
            		break;
            	case '4':
            		// Удаление репозитория
            		$rep =& $db->query("SELECT * FROM repository WHERE rep_id='$uid'");
            		$rep->fetchInto($info, DB_FETCHMODE_ASSOC);
			$display  = "<h3>Удаление репозитория ".$info["repname"]." для <em>".$dist_name."</em></h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='9'>\n";
			$display .= "<input type='hidden' name='rep' value='$uid'>\n";
			$display .= "<input type='submit' value='Удалить'></form>\n";			
            		
            		break;
            }
            break;
        case '4':
            // Управление разделами
            switch ($act) {
        	case '0':
        		// Список секций
        		$req =& $db->query("SELECT * FROM section");
        		$display = "<p>Имеющиеся секции в репозиториях</p><ul class='sectlist'>";
        		while ($req->fetchInto($sect, DB_FETCHMODE_ASSOC)) {
        		    $sreq =& $db->query("SELECT * FROM distribution d JOIN sect2dist s ON s.dist_id=d.dist_id WHERE s.sect_id='".$sect["sect_id"]."'");
        		    $replist = "<small>Используется в ";
        		    while ($sreq->fetchInto($rep, DB_FETCHMODE_ASSOC)) {
        			$replist .= "<em>".stripslashes($rep["distname"])."</em>, ";
        		    }
        		    $replist = substr($replist, 0, -2);
        		    $replist .= "</small>";
        		    $display .= "<li><strong>".stripslashes($sect["sectname"])."</strong> &mdash; [<a href='./admin.php?mode=4&action=2&uid=".$sect["sect_id"]."' class='edit'>править</a>][<a href='./admin.php?mode=4&action=3&uid=".$sect["sect_id"]."' class='delete'>удалить</a>] &mdash; ".stripslashes($sect["sectinfo"])."<br>".$replist."</li>";
        		}
        		$display .= "</ul><p><a href='./admin.php?mode=4&action=1'>Добавить секцию</a></p>";
        		break;
        	case '1':
        		$req =& $db->query("SELECT * FROM distribution");
        		while ($req->fetchInto($dist, DB_FETCHMODE_ASSOC)) {
        		    $list .= "<br><input type='checkbox' name='dist' value='".$dist["dist_id"]."'>".stripslashes($dist["distname"])." ";
        		}
			$display  = "<h3>Создание секции репозитория</h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='10'>\n";
			$display .= "Название секции (codename): <input type='text' name='sectName'><br>\n";
			$display .= "Описание секции:<br> <textarea name='sectInfo'></textarea><br>\n";
                        $display .= "Используется в дистрибутивах: ".$list;
			$display .= "<br><input type='submit' value='Добавить'></form>\n";			
        		break;
        	case '2':
        		$req =& $db->query("SELECT * FROM distribution d JOIN sect2dist s ON s.dist_id=d.dist_id WHERE s.sect_id='$uid'");
        		if ($req->numRows()>0) {
            		    while ($req->fetchInto($dist, DB_FETCHMODE_ASSOC)) {
        			$list .= "<br><input type='checkbox' name='dist[]' value='".$dist["dist_id"]."' checked>".stripslashes($dist["distname"])." ";
        		    }
        		}
        		$req =& $db->query("SELECT d.* FROM distribution d WHERE dist_id NOT IN (SELECT dist_id FROM sect2dist WHERE sect_id='$uid')");
        		if ($req->numRows()>0) {
        		    while ($req->fetchInto($dist, DB_FETCHMODE_ASSOC)) {
        			$list .= "<br><input type='checkbox' name='dist[]' value='".$dist["dist_id"]."'>".stripslashes($dist["distname"])." ";
        		    }
        		}
        		$req =& $db->query("SELECT * FROM section WHERE sect_id='$uid'");
        		$req->fetchInto($sect, DB_FETCHMODE_ASSOC);
			$display = "<h3>Правка секции репозитория</h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='11'>\n";
			$display .= "<input type='hidden' name='sectID' value='$uid'>\n";			
			$display .= "Название секции (codename): <input type='text' name='sectName' value='".stripslashes($sect["sectname"])."'><br>\n";
			$display .= "Описание секции:<br> <textarea name='sectInfo'>".stripslashes($sect["sectinfo"])."</textarea><br>\n";
                        $display .= "Используется в дистрибутивах: ".$list;
			$display .= "<br><input type='submit' value='Править'></form>\n";			
        		break;
        	case '3':
        		$req =& $db->query("SELECT * FROM section WHERE sect_id='$uid'");
        		$req->fetchInto($sect, DB_FETCHMODE_ASSOC);
			$display = "<h3>Удаление секции <em>".stripslashes($sect["sectname"])."</em></h3>";
			$display .= "<form action='./process.php' method='POST'>\n";
			$display .= "<input type='hidden' name='mode' value='12'>\n";
			$display .= "<input type='hidden' name='sectID' value='$uid'>\n";			
			$display .= "<br><input type='submit' value='Удалить'></form>\n";			
        		break;
            }
            break;
}

$smarty->assign('display',$display);
$smarty->display('admin.tpl');

?>
